import * as React from "react";
export type OnPressFunction = (e?: React.TouchEvent | React.MouseEvent | React.KeyboardEvent | Event) => void;
export interface PressableOptions {
    behavior?: "button" | "link";
    disabled?: boolean;
    onPress?: OnPressFunction;
}
export interface PressableResult {
    hover: boolean;
    bind: {
        onKeyDown: (e: React.KeyboardEvent) => void;
        onKeyUp: (e: React.KeyboardEvent) => void;
        onMouseEnter: (e: React.TouchEvent | React.MouseEvent | React.KeyboardEvent | Event) => void;
        onMouseLeave: (e: React.TouchEvent | React.MouseEvent | React.KeyboardEvent | Event) => void;
        onClick?: ((e: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
    };
    active: boolean;
}
/**表示某一个小div区域可以按下点击 触发函数。 返回bind? 同一个名字onXXX()可能冲突;
 * 点按 不是拖拽拉动的，相对位置是静止的，按住时间长短？才算，立刻反馈被您点到了。
 * Hook：原版乃是touchable-hook这个包的。
 * @param options
 * 本函数返回的类型声明的近20个参数对象实际是自动生成的代码，非人工编辑的。
 * 这里ListItem MenuItem IconButton Button 这四个都直接用到useTouchable的 点按触发。
 * 【淘汰中】？ 关键# 这个用了"react-gesture-responder"
 * #计划"react-gesture-responder"删除！！： #把 ListItem MenuItem Button这几个用useTouchable全都改掉？ 或useTouchable直接改？
 * @消除依赖 react-gesture-responder 参考https://use-gesture.netlify.app/docs/examples/
 * ?考虑添加 ：上级组件轮播台context正在被拉动的可能允许取消当前的 onClick onPress触发。?代码关联性太强了。牵涉范围太广泛，得不偿失！。
 */
export declare function usePressable({ onPress, behavior, disabled, }: PressableOptions): PressableResult;
